package mima.presentation.gwt.node;

import mima.domain.SubNode;

import com.google.gwt.user.client.Command;
import com.google.gwt.user.client.ui.MenuBar;
import com.google.gwt.user.client.ui.PopupPanel;


/**
 * @author Virginio Carfagno
 */
public class SubNodeView extends NodeView {

	private static final String COMMAND_TITLE_CUT_NODE = "Cut Node";
	
	
	public SubNodeView(SubNode subNode) {
		super(subNode, subNode.isRight());
		if (IsCreateSubNode)
			showTitleEditor(true);
	}
	

	protected MenuBar createPopupMenu(PopupPanel popupPanel) {
		MenuBar popupMenu = super.createPopupMenu(popupPanel);
		popupMenu.addItem(COMMAND_TITLE_CUT_NODE, createCutNodeCommand(popupPanel));
		
		return popupMenu;
	}
	
	private Command createCutNodeCommand(PopupPanel popupMenu) {
		return new HidePopupMenuCommand(popupMenu) {
			public void doExecute() {
				CuttedSubNode = getSubNode();
				getSubNode().removeFromSuperNode();
			}
		};
	}
	
	private SubNode getSubNode() {
		return (SubNode)getNode();
	}
}
