package mima.presentation.gwt.nodecomponent;

import com.google.gwt.user.client.ui.Composite;


/**
 * Pattern Decorator
 * 
 * @author Virginio Carfagno
 */
public abstract class NodeComponent extends Composite {

	/**
	 * The Decorator of this component
	 */
	private NodeFrame _nodeFrame;
	
	
	protected void fireNodeComponentChanged() {
		if (hasNodeFrame()) {
			_nodeFrame.nodeComponentChanged();
			_nodeFrame.fireNodeComponentChanged();
		}
	}

	public abstract int getAbsoluteEdgeConnectionPointY();
	
	private boolean hasNodeFrame() {
		return _nodeFrame != null;
	}

	protected void setNodeFrame(NodeFrame nodeFrame) {
		_nodeFrame = nodeFrame;
	}

}
