package mima.presentation.gwt.nodeeditor;

import mima.domain.Node;

import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.TextArea;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;


/**
 * @author Virginio Carfagno
 */
public class NodeEditor extends DialogBox {

	private static final String NODE_EDITOR_TITLE = "Edit Note";
	private static final String LINK_EDITOR_TITLE = "Edit Link";
	

	public NodeEditor(int left, int top, final Node node, final boolean isEditLink) {
		super(false);
		
		// TODO Whrend im Hosted Mode der Cursor angezeigt wird, wird er im
		// FireFox nicht angezeigt. Scheint ein BUG zu sein. Vielleicht sollte
		// ein Workaround entwickelt werden.
		final TextArea textArea = new TextArea() {
			protected void onLoad() {
				setFocus(true);
			}
		};
		textArea.setCharacterWidth(30);
		textArea.setVisibleLines(10);
		
		if (isEditLink) {
			textArea.setText("http://");
			setText(LINK_EDITOR_TITLE);
		}
		else {
			setText(NODE_EDITOR_TITLE);
		}
		
		Button acceptButton = new Button("Accept");
		acceptButton.addClickListener(new ClickListener() {
			public void onClick(Widget sender) {
				if (isEditLink)
					node.setLink(textArea.getText());
				else
					node.setNote(textArea.getText());
				hide();
			}
		});
		
		Button cancelButton = new Button("Cancel");
		cancelButton.addClickListener(new ClickListener() {
			public void onClick(Widget sender) {
				hide();
			}
		});
		
		HorizontalPanel buttonBox = new HorizontalPanel();
		buttonBox.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_RIGHT);
		buttonBox.add(acceptButton);
		buttonBox.add(cancelButton);
		
		VerticalPanel componentBox = new VerticalPanel();
		componentBox.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_RIGHT);
		componentBox.add(textArea);
		componentBox.add(buttonBox);
		
		setWidget(componentBox);
		setPopupPosition(left, top);
		show();
	}

}
