package mima.presentation.gwt.nodeframes;

import mima.presentation.gwt.nodecomponent.NodeComponent;
import mima.presentation.gwt.nodecomponent.NodeFrame;
import mima.presentation.gwt.util.WidgetUtilities;

import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;
import com.gwt.components.client.Canvas;


/**
 * @author Virginio Carfagno
 */
public class UnderlineFrame extends NodeFrame {
	
	private Widget _line;
	private VerticalPanel _panel;
	
	
	public UnderlineFrame(NodeComponent nodeComponent) {
		super(nodeComponent);
		_panel = new VerticalPanel();
		_panel.add(nodeComponent);
		initWidget(_panel);
		_panel.setStyleName("mima-UnderlineFrame");
	}
	

	private Widget createLine() {
		Canvas canvas = new Canvas(getLineLength(), 1);
		canvas.rect(0, 0, getLineLength(), 0);
		canvas.setStrokeColor("blue");
		canvas.stroke();
		return canvas;
	}
	
	public int getAbsoluteEdgeConnectionPointY() {
		return WidgetUtilities.getAbsoluteBottom(this);
	}
	
	private int getLineLength() {
		return getNodeComponent().getOffsetWidth();
	}
	
	private void invariant() {
		assert _panel != null;
		assert getNodeComponent().getParent() == _panel;
	}
	
	protected void nodeComponentChanged() {
		redraw();
	}
	
	private void redraw() {
		invariant();
		
		if (_line != null) {
			_panel.remove(_line);
			assert _line.getParent() == null;
		}
		
		_line = createLine();

		_panel.add(_line);
		
		assert _line.getParent() == _panel;
		invariant();
	}

}
