package mima.presentation.gwt.util;

import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.Event;


/**
 * @author Virginio Carfagno
 */
public class MouseUtilities {

	public static int getEventType(Event event) {
		return DOM.eventGetType(event);
	}

	public static int getX(Event event) {
		return DOM.eventGetClientX(event);
	}

	public static int getY(Event event) {
		return DOM.eventGetClientY(event);
	}

	public static boolean isLeftButton(Event event) {
		return DOM.eventGetButton(event) == Event.BUTTON_LEFT;
	}

	public static boolean isOnClick(Event event) {
		return getEventType(event) == Event.ONCLICK;
	}

	public static boolean isOnDoubleClick(Event event) {
		return getEventType(event) == Event.ONDBLCLICK;
	}

	public static boolean isOnDown(Event event) {
		return getEventType(event) == Event.ONMOUSEDOWN;
	}

	public static boolean isOnMove(Event event) {
		return getEventType(event) == Event.ONMOUSEMOVE;
	}

	public static boolean isOnOut(Event event) {
		return getEventType(event) == Event.ONMOUSEOUT;
	}

	public static boolean isOnOver(Event event) {
		return getEventType(event) == Event.ONMOUSEOVER;
	}

	public static boolean isOnUp(Event event) {
		return getEventType(event) == Event.ONMOUSEUP;
	}

	public static boolean isRightButton(Event event) {
		return DOM.eventGetButton(event) == Event.BUTTON_RIGHT;
	}

}
