package mima.domain;



/**
 * @author Virginio Carfagno
 */
public class CentralNodeTest extends NodeTest {

	private CentralNode _centralNode;
	
	
	protected Node createNode() {
		return new CentralNode();
	}
	
	protected void setUp() throws Exception {
		super.setUp();
		_centralNode = new CentralNode();
	}
	
	
	public void testCreateCentralNode() {
		assertEquals("Edit this node", _centralNode.getTitle());
		assertEquals(Node.Frame.CIRCLE, _centralNode.getFrame());
	}
	
	
	public void testIsRight() {
		SubNode subNode1 = new SubNode(_centralNode);
		assertTrue(subNode1.isRight());
		
		SubNode subNode2 = new SubNode(_centralNode);
		assertFalse(subNode2.isRight());
		
		SubNode subNode3 = new SubNode(_centralNode);
		assertTrue(subNode3.isRight());
		
		SubNode subNode4 = new SubNode(subNode1);
		assertTrue(subNode4.isRight());
		
		SubNode subNode5 = new SubNode(subNode2);
		assertFalse(subNode5.isRight());
		
		subNode5.setSuperNode(subNode3);
		assertTrue(subNode5.isRight());
		
		subNode2.removeFromSuperNode();
		assertTrue(subNode1.isRight());
		assertTrue(subNode3.isRight());
		
		subNode2.setSuperNode(_centralNode);
		assertFalse(subNode2.isRight());
	}

	
}
