package mima.domain;



/**
 * @author Virginio Carfagno
 */
public class SubNodeTest extends NodeTest {

	protected Node createNode() {
		return new SubNode( new CentralNode());
	}
	
	
	public void testRemoveFromSuperNode() {
		CentralNode centralNode = new CentralNode();
		
		SubNode subNode1 = new SubNode(centralNode);
		assertTrue(centralNode.hasSubNodes());
		
		subNode1.removeFromSuperNode();
		assertFalse(centralNode.hasSubNodes());
	}
	
	public void testSetSuperNode() {
		CentralNode centralNode = new CentralNode();
		
		SubNode subNode1 = new SubNode(centralNode);
		SubNode subNode2 = new SubNode(centralNode);
		SubNode subNode3 = new SubNode(subNode1);
		
		assertTrue(subNode1.hasSubNodes());
		assertFalse(subNode2.hasSubNodes());
		
		subNode3.setSuperNode(subNode2);
		
		assertTrue(subNode2.hasSubNodes());
		assertFalse(subNode1.hasSubNodes());
	}

}
